; 1. rsz
; LED villogtatsa mikrovezrlvel + 2 nyomgomb kezelse
;
; Ltrehozva: 2005.05.25
; ksasa

.include "2313def.inc"

; vltozk definilsa
.def temp = r16
.def osztasi_ertek = r17
.def timer_int = r18

; konstansok definilsa
.equ LED = 2 ;LED kimenet portb.2
.equ sw1 = 1 ;nyomgomb 1 portb.1
.equ sw2 = 0 ;nyomgomb 2 portb.0


;program kezdete
.CSEG	

;IT vektortbla
.org 0
	rjmp stackinit ; reset it
	reti		   ; int0  it
	rjmp timer_int ; timer it

;Stack bellits
stackinit:
	ldi temp,ramend		;Stack inicializls
	out SPL,temp		;Stack Pointer Low

;PORT B bellitsok
	ldi temp,(1<<LED) 			;portb.2 kimenet, portb.1 s .0 bemenet
	out ddrb,temp
	ldi temp,(1<<sw1)+(1<<sw2)	;ddb.0 s .1 H-ba llitva,
	out portb,temp	  			;igy a bemeneteken lesz PULLUP (elvileg)

;timer init
;kvarc = 4MHz
	ldi temp, (1<<cs02)+(1<<cs00)	;4Mhz/1024 ;eloszts bellitsa
	out	tccr0,temp

	ldi osztasi_ertek,0	;osztsi alaprtk:256, vagyis 4MHz/1024/256=15,258Hz
	out	tcnt0,osztasi_ertek

	ldi temp,1<<toie0	;timer megszakits engedlyezse
	out	timsk,temp

	sei					;magszkitsok engedlyezse

;vgtelen ciklus
	ldi timer_int,0		;timer int szmll inicializls	

x:	cpi timer_int,15	;15 db timer megszakits bevrsa
	breq led_csere		;ha megvan, LED llapot vltsa

	sbis portb,sw1		;elenrizzk, van e sw1 gombnyoms
	rjmp sw1_lenyomva	;ha van sw1, 1.5Hz-et llitunk be

	sbis portb,sw2		;elenrizzk, van e sw2 gombnyoms
	rjmp sw2_lenyomva	;ha van sw2, 2Hz-et llitunk be
	
	rjmp x				;ha egyik sincs lenyomva, vissza az elejre

sw1_lenyomva:			  ;sw1 megnyomsa esetn a freki legyen 1.5Hz
	ldi osztasi_ertek,82  ;4Mhz/1024/(256-82)/15 = 1.4966Hz
	out tcnt0,osztasi_ertek
	rjmp x				  ;majd vissza az elejre

sw2_lenyomva:			  ;sw2 megnyomsa esetn a freki legyen 2Hz
	ldi osztasi_ertek,126 ;4Mhz/1024/(256-126)/15 = 2.003Hz
	out tcnt0,osztasi_ertek
	rjmp x				  ;majd vissza az elejre


led_csere:
	ldi timer_int,0		;elszr is trljk a timer int szlmlt
	sbic portb,LED	
	rjmp clr_LED		;ha a led vilgit, akkor kikapcsoljuk	
	sbi portb,LED		;ha nem vilgit, bekapcsoljuk
	rjmp x

clr_led:
	cbi portb,LED		;itt trtnik a kikapcsols
	rjmp x

	


timer_int:
	out tcnt0,osztasi_ertek ;szmll jratltse
	inc timer_int
	reti


